#include <iostream>
#include <vector>
#include <unordered_map>

using ll = long long;
using ld = long double;

using namespace std;

int h, w;

int f(int i, ll s, vector<ll>& v) {
    if (i == w)
        return s ? -1 : 0;
    if (s && v[i] > s)
        return -1;
    // if (dp[i].find(s) != dp[i].end())
    //return dp[i][s];
    auto r1 = f(i + 1, s - v[i], v);
    if (r1 != -1) {
        r1 |= (1 << i);
        //dp[i][s] = r1;
        return r1;
    }
    auto r2 = f(i + 1, s, v);
    if (r2 != -1) {
        //dp[i][s] = r2;
        return r2;
    }
    return -1;
}

void solve() {
    cin >> h >> w;
    bool flag = true;
    vector<vector<int>> matrix(h, vector<int> (w));
    ll total_sum = 0;
    for (int i = 0; i < h; i++) {
        for (int j = 0; j < w; j++) {
            cin >> matrix[i][j];
            total_sum += matrix[i][j];
            if (matrix[i][j] > 6)
                flag = false;
        }
    }
    if (total_sum < 225)
        flag = true;
    ll arr[w][1 << h];
    for (int mask = 1; mask < (1 << h); mask++) {
        for (int i = 0; i < w; i++) {
            arr[i][mask] = 0;
            for (int j = 0; j < h; j++) {
                if (mask & (1 << j))
                    arr[i][mask] += matrix[j][i];
            }
        }
    }
    ll s;
    cin >> s;
    if (s > total_sum) {
        cout << "NO";
        return;
    }
    for (int mask = 1; mask < (1 << h); mask++) {
        vector<ll> v(w, 0);
        for (int i = 0; i < w; i++)
            v[i] = arr[i][mask];
        if (!flag) {
            for (int mask2 = 1; mask2 < (1 << w); mask2++) {
                ll sum = 0;
                for (int i = 0; i < w; i++) {
                    if (mask2 & (1 << i))
                        sum += v[i];
                    if (sum > s)
                        break;
                }
                if (sum == s) {
                    cout << "YES\n";
                    vector<pair<int, int>> operations;
                    int k = 0;
                    for (int i = 0; i < h; i++) {
                        if (!(mask & (1 << i))) {
                            operations.emplace_back(1, i + 1);
                            k++;
                        }
                    }
                    k = 0;
                    for (int i = 0; i < w; i++) {
                        if (!(mask2 & (1 << i))) {
                            operations.emplace_back(2, i + 1);
                            k++;
                        }
                    }
                    cout << operations.size() << '\n';
                    for (auto [t, i]: operations)
                        cout << t << ' ' << i << '\n';
                    return;
                }
            }
        } else {
            //dp.assign(w, {});
            vector<vector<int>> dp(w + 1, vector<int> (total_sum + 1, -1));
            dp[w][0] = 0;
            for (int i = w - 1; i >= 0; i--) {
                for (int a = 0; a < total_sum + 1; a++) {
                    int r1 = dp[i + 1][a];
                    if (r1 != -1) {
                        dp[i][a] = r1;
                        continue;
                    }
                    if (a >= v[i]) {
                        int r2 = dp[i + 1][a - v[i]];
                        if (r2 != -1) {
                            dp[i][a] = r2 | (1 << i);
                            continue;
                        }
                    }
                    dp[i][a] = -1;
                }
            }
            int res = dp[0][s];
            if (res == -1)
                continue;
            cout << "YES\n";
            vector<pair<int, int>> operations;
            int k = 0;
            for (int i = 0; i < h; i++) {
                if (!(mask & (1 << i))) {
                    operations.emplace_back(1, i + 1);
                    k++;
                }
            }
            k = 0;
            for (int i = 0; i < w; i++) {
                if (!(res & (1 << i))) {
                    operations.emplace_back(2, i + 1);
                    k++;
                }
            }
            cout << operations.size() << '\n';
            for (auto [t, i]: operations)
                cout << t << ' ' << i << '\n';
            return;
        }
    }
    cout << "NO";
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
