#include <iostream>
#include <vector>
#include <queue>
#include <set>

using ll = long long;
using ld = long double;

using namespace std;

vector<vector<int>> graph;
vector<int> depth;
vector<bool> used;

int dfs(int v) {
    used[v] = true;
    int mx = 0;
    for (int u : graph[v]) {
        if (!used[u])
            mx = max(mx, dfs(u));
    }
    return depth[v] = mx + 1;
}

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    graph.resize(n, vector<int> ());
    used.resize(n, false);
    depth.resize(n, 0);
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        graph[v].push_back(u);
        graph[u].push_back(v);
    }
    dfs(0);
    multiset<int> st;
    st.insert(1);
    for (int u : graph[0])
        st.insert(depth[u] + 1);
    int ans = 1e9;
    for (int u : graph[0]) {
        auto it = st.rbegin();
        if (u == *it)
            ans = min(ans, *(it--));
        else
            ans = min(ans, *it);
    }
    cout << ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
