#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>

using ll = long long;
using ld = long double;

using namespace std;

vector<vector<int>> graph;

void solve() {
    int n, k, t;
    cin >> n >> k >> t;
    graph.resize(n, vector<int> ());
    for (int i = 0; i < n - 1; i++) {
        int v, u;
        cin >> v >> u;
        v--; u--;
        graph[v].push_back(u);
        graph[u].push_back(v);
    }
    int ans = 1e9;
    if (k == 1) {
        for (int v = 0; v < n; v++) {
            graph[0].push_back(v);
            queue<int> q;
            q.push(0);
            vector<bool> used(n, false);
            used[0] = true;
            vector<int> dist(n);
            dist[0] = 0;
            int mx = 0;
            while (!q.empty()) {
                int p = q.front();
                q.pop();
                for (int u : graph[p]) {
                    if (!used[u]) {
                        dist[u] = dist[p] + 1;
                        mx = max(mx, dist[u]);
                        used[u] = true;
                        q.push(u);
                    }
                }
            }
            ans = min(ans, mx);
            graph[0].pop_back();
        }
        cout << ans;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
