#include <iostream>
#include <vector>
#include <set>

using ll = long long;
using ld = long double;

using namespace std;

bool is_prime(int x) {
    for (int i = 2; i * i < x; i++) {
        if (!(x % i))
            return false;
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int& x : v)
        cin >> x;
    vector<int> color(n, 1);
    set<int> st;
    for (int i = 0; i < n; i++) {
        vector<int> divisors;
        int x = v[i];
        for (int i = 2; i * i <= x; i++) {
            if (is_prime(x / i))
                divisors.push_back(i);
            if (i * i != x && is_prime(i))
                divisors.push_back(x / i);
        }
        for (int d : divisors) {
            if (st.find(d) != st.end())
                color[i] = 2;
        }
        if (color[i] == 1)
            st.insert(x);
    }
    for (int c : color)
        cout << c << ' ';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
