#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>

using ll = long long;
using ld = long double;

using namespace std;

bool is_prime(int x) {
    if (x == 1)
        return false;
    for (int i = 2; i * i <= x; i++) {
        if (!(x % i))
            return false;
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int& x : v)
        cin >> x;
    vector<int> color(n, 0);
    vector<bool> end(n, false), handled(n, false);
    end[0] = true;
    map<int, set<int>> mp;
    for (int i = 0; i < n; i++) {
        mp[v[i]].insert(i);
    }
    queue<pair<int, int>> to_end;
    for (int i = 0; i < n; i++) {
        if (to_end.empty()) {
            auto [e, idxs] = *mp.begin();
            to_end.emplace(e, *idxs.begin());
            mp[e].erase(*idxs.begin());
            if (mp[e].empty())
                mp.erase(e);
        }
        auto [e, idx] = to_end.front();
        to_end.pop();
        vector<int> to_delete;
        for (auto [e1, idxs]: mp) {
            if ((e % e1 == 0 && is_prime(e / e1)) || (e1 % e == 0 && is_prime(e1 / e))) {
                for (int idx1 : idxs) {
                    color[idx1] = !color[idx];
                    to_end.emplace(e1, idx1);
                    to_delete.push_back(e1);
                }
            }
        }
        for (int e1: to_delete) {
            mp.erase(e1);
        }
    }
    for (int c : color)
        cout << c + 1 << ' ';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
