#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using ll = long long;
using ld = long double;

using namespace std;

bool is_prime(int x) {
    if (x == 1)
        return false;
    for (int i = 2; i * i <= x; i++) {
        if (!(x % i))
            return false;
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector<int> primes;
    vector<int> sieve(n + 1, true);
    for (ll i = 2; i <= n; i++) {
        if (sieve[i]) {
            primes.push_back(i);
            for (ll j = i * i; j <= n; j += i) {
                sieve[j] = false;
            }
        }
    }
    vector<int> v(n);
    for (int& x : v)
        cin >> x;
    vector<int> color(n, 0);
    vector<bool> end(n, false), handled(n, false);
    end[0] = true;
    map<int, set<int>> mp;
    for (int i = 0; i < n; i++) {
        mp[v[i]].insert(i);
    }
    queue<pair<int, int>> to_end;
    for (int i = 0; i < n; i++) {
        if (to_end.empty()) {
            auto [e, idxs] = *mp.begin();
            to_end.emplace(e, *idxs.begin());
            mp[e].erase(*idxs.begin());
            if (mp[e].empty())
                mp.erase(e);
        }
        auto [e, idx] = to_end.front();
        to_end.pop();
        vector<int> to_delete;
        for (int prime : primes) {
            if (!(e % prime)) {
                for (int idx1 : mp[e / prime]) {
                    color[idx1] = !color[idx];
                    to_end.emplace(e / prime, idx1);
                }
                to_delete.push_back(e / prime);
            }
            ll p = e * prime;
            if (p > n + 1)
                continue;
            for (int idx1 : mp[e * prime]) {
                color[idx1] = !color[idx];
                to_end.emplace(e * prime, idx1);
            }
            to_delete.push_back(e * prime);
        }
        if (is_prime(e)) {
            for (int idx1 : mp[e]) {
                color[idx1] = !color[idx];
                to_end.emplace(e, idx1);
            }
            to_delete.push_back(e);
        }
        for (int e1: to_delete) {
            mp.erase(e1);
        }
    }
    for (int c : color)
        cout << c + 1 << ' ';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
