#include <iostream>
#include <vector>
#include <set>

using ll = long long;
using ld = long double;

using namespace std;

bool is_prime(int x) {
    if (x == 1)
        return false;
    for (int i = 2; i * i <= x; i++) {
        if (!(x % i))
            return false;
    }
    return true;
}

vector<int> color;
set<int> st;
vector<int> vec;

void dfs(int v, int k) {
    color[v] = k;
    st.erase(st.begin());
    int cnt = 0;
    while (!st.empty() && cnt < st.size()) {
        int u = *st.begin();
        //st.erase(st.begin());
        if (u == v)
            continue;
        cnt++;
        if ((vec[u] % vec[v] == 0 && is_prime(vec[u] / vec[v])) || (vec[v] % vec[u] == 0 && is_prime(vec[v] / vec[u])))
            dfs(u, !k);
    }
}

void solve() {
    int n;
    cin >> n;
    vec.resize(n);
    for (int& x : vec)
        cin >> x;
    color.resize(n, -1);
    for (int i = 0; i < n; i++)
        st.insert(i);
    for (int i = 0; i < n; i++) {
        if (color[i] == -1)
            dfs(i, 0);
    }
    for (int c : color)
        cout << c + 1 << ' ';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
