#include <iostream>
#include <vector>
#include <set>

using ll = long long;
using ld = long double;

using namespace std;

bool is_prime(int x) {
    for (int i = 2; i < x; i++) {
        if (!(x % i))
            return false;
    }
    return true;
}

void solve() {
    int n;
    cin >> n;
    vector<int> v(n);
    for (int& x : v)
        cin >> x;
    vector<int> color(n, 0);
    set<int> st;
    for (int i = 0; i < n; i++) {
        vector<int> divisors;
        for (int j = i + 1; j < n; j++) {
            if ((v[j] % v[i] == 0 && is_prime(v[j] / v[i])) || (v[i] % v[j] == 0 && is_prime(v[i] / v[j])))
                color[j] = !color[i];
            else
                color[j] = color[i];
        }
    }
    for (int c : color)
        cout << c + 1 << ' ';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
