#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using ll = long long;
using ld = long double;

using namespace std;

int bin_pow(int n, int p) {
    if (!p)
        return 1;
    if (p & 1)
        return bin_pow(n, p - 1) * n;
    int r = bin_pow(n, p / 2);
    return r * r;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<ll, ll>> events;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        events.emplace_back(a[i], 1);
    }
    ll mn = 1e18;
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        events.emplace_back(a[i] + t, -1);
        mn = min(mn, a[i] + t);
    }
    for (int i = 1; i < 45; i++)
        events.emplace_back(mn + i, -5);
    sort(events.begin(), events.end());
    if (m == 1) {
        cout << events[0].first;
        return;
    }
    __int128 total = 1, inc = 0;
    ll pr_inc = 0, pr_total = 0;
    for (int i = 1; i < events.size(); i++) {
        auto [t, e] = events[i];
        if (t > mn + 45)
            break;
        if (events[i - 1].first != events[i].first)
            total += (inc << ll(events[i].first - events[i - 1].first)) - inc;
        inc += (inc << ll(events[i].first - events[i - 1].first)) - inc;
        if (e == 1) {
            total++;
        } else if (e == -1) {
            inc += 2;
            total += 1;
        }
        if (total == m) {
            cout << t;
            return;
        } else if (total > m)
            break;
        pr_inc = inc;
        pr_total = total;
    }
    cout << -1;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
