#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using ll = long long;
using ld = long double;

using namespace std;

int bin_pow(int n, int p) {
    if (!p)
        return 1;
    if (p & 1)
        return bin_pow(n, p - 1) * n;
    int r = bin_pow(n, p / 2);
    return r * r;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<pair<int, int>> events;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        events.emplace_back(a[i], 1);
    }
    for (int i = 0; i < n; i++) {
        int t;
        cin >> t;
        events.emplace_back(a[i] + t, -1);
    }
    events.emplace_back(2e9, -1);
    sort(events.begin(), events.end());
    ll total = 1, inc = 0;
    for (int i = 1; i < events.size(); i++) {
        auto [t, e] = events[i];
        if (events[i - 1].first != events[i].first)
            total += (inc << (events[i].first - events[i - 1].first)) - inc;
        inc += (inc << (events[i].first - events[i - 1].first)) - inc;
        if (e == 1) {
            total++;
        } else {
            inc += 2;
            total += 1;
        }
        if (total >= m) {
            if (m == total) {
                cout << t;
                return;
            }
            if (events[i - 1].second == 1) {
                cout << -1;
                return;
            }
            total -= (1 << (events[i].first - events[i - 1].first)) - inc;
            inc -= (inc << (events[i].first - events[i - 1].first)) - inc;
            int l = events[i - 1].first, r = events[i].first + 1;
            while (l + 1 < r) {
                int mid = l + (r - l) / 2;
                if (total + (inc << (mid - t)) - inc <= m)
                    l = mid;
                else
                    r = mid;
            }
            if (total + (inc << (l - t)) - inc == m)
                cout << l;
            else
                cout << -1;
            return;
        } else if (events[i + 1].first - events[i].first > 100 && m - total < inc << (32 - (int)log2(inc))) {
            if (m == total) {
                cout << t;
                return;
            }
            int l = events[i].first, r = events[i].first + (32 - (int)log2(inc));
            while (l + 1 < r) {
                int mid = l + (r - l) / 2;
                if (total + (inc << (mid - t)) - inc <= m)
                    l = mid;
                else
                    r = mid;
            }
            if (total + (inc << (l - t)) - inc == m)
                cout << l;
            else
                cout << -1;
            return;
        }
    }
    cout << -1;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}
